/*
  CLIgen is a CLI generator. 

  Copyright (C) 2001-2014 Olof Hagsand

  This file is part of CLIgen.

  CLIgen is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  CLIgen is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with CLIgen; see the file COPYING.
*/

/* 
   You include cligen.h which includes the other cligen include files for you.
   All cligen include files are placed in the sub-directory cligen/cligen*.h. 
*/
#include <stdio.h>
#include <netinet/in.h>

/* CLIgen handle for external API. See cligen_config.h for internal functions. */
#ifndef _CLIGEN_H_
#define _CLIGEN_H_
#if 1 /* SANITY CHECK */
typedef struct {int a;} *cligen_handle;
#else
typedef void *cligen_handle; /* API */
#endif
#endif  /* _CLIGEN_H_ */


/* This is for backward compatibility with int and long types that should be 
 * replaced with int32 and int64 respectively. Also, you can choose from uints and
 * 8/16/32/64 ints in the new system
 */
#define CLIGEN_COMPAT_INT 1

#include <cligen/cligen_buf.h>
#include <cligen/cligen_var.h>
#include <cligen/cligen_cvec.h>
#include <cligen/cligen_gen.h>
#include <cligen/cligen_handle.h>
#include <cligen/cligen_print.h>
#include <cligen/cligen_read.h>
#include <cligen/cligen_io.h>
#include <cligen/cligen_expand.h>
#include <cligen/cligen_syntax.h>
#include <cligen/cligen_util.h>

/*
 * Global variables generated by Makefile
 */
extern const char CLIGEN_BUILDSTR[];
extern const char CLIGEN_VERSION[];

